---
title: Home
---
# Welcome to iceoryx.io

<p align="center">
    <img src="https://user-images.githubusercontent.com/8661268/70233652-4aa6d180-175f-11ea-8524-2344e0d3935c.png"
        width="50%">
</p>

Eclipse iceoryx is a true zero-copy inter-process communication that allows virtually limitless data transfer at constant time.

On the follow pages you find everything you need to get started using Eclipse iceoryx:

* [Overview and key concepts](getting-started/overview.md)
* [Installation](getting-started/installation.md)
* [Basic examples](getting-started/basic-examples.md)

<table>
<tr>
<td>Easy</td>
<td>Safe</td>
<td>Fast</td>
</tr>
<tr>
<td>
<ul>
<li>Simple publish-subscribe API with service discovery</li>
<li>Straightforward usage for ROS2 and Adaptive AUTOSAR</li>
<li>Runs on QNX, Linux, MacOS and Windows</li>
<br>
Learn more
</ul>
</td>
<td>
<ul>
<li>Automotive-grade (ISO26262 certification ongoing)</li>
<li>Lock-free algorithms prevent deadlocks</li>
<li>Huge library with safe STL implementations</li>
<br>
Learn more
</ul>
</td>

<td>
<ul>
<li>Written in C++14</li>
<li>C binding available</li>
<li>Zero-copy data transmission with shared memory</li>
<li>Ultra low latency</li>
<br>
Learn more
</ul>
</td>
</tr>
</table>
